#ifdef DEVICE

#endif

#define DEVCONST_TAB_LEN ((Uint16) 56)      // Micro stress table length
#define SENCONST_TBL_LEN ((Uint16) 14)		// Sensor table length

// Motor
#define KM_MOTOR 0.0301 //A/Nm

// Parameter for Torque reserve 6%
#define TORQUE_LIMIT	(float)1.06

// macros for fixed Device Parameters
#define	CONST_ENCODER	2500.0
#define	CONST_INTERPOL	2000.0

// macros for Device Constants
#define	TYPE		0
#define	CAL1_MOTOR	1
#define	CAL2_MOTOR	2
#define	CAL3_MOTOR	3
#define	CAL4_MOTOR	4
#define	J_MOTOR		5
#define	OMEGAMAX	6
#define	TORQUMAX	7
#define	DC8			8
#define	DC9			9

#define	IMAX_AMPL	10
#define	RAWDATA		11
#define	IOFF_1_AMPL	12
#define	IOFF_2_AMPL	13
#define	IOFF_3_AMPL	14
#define	ICAL_1_AMPL	15
#define	ICAL_2_AMPL	16
#define	ICAL_3_AMPL	17
#define	DC18		18
#define	DC19		19

// macros for Sensor Constants
#define	TYPE		0
#define	AFACTOR		1
#define	MFACTOR		2
#define	DAMP		3
#define	J_SENS		4
#define COMPLIANCE	5


// macros for device types
#define  DEV_VTIQ		1
#define  DEV_K2			2

// Sensor Typen
#define   STYP_NONE		0
#define   STYP_PP		1
#define   STYP_PK		2
#define   STYP_ZYL		3
#define   STYP_DZYL		4
#define   STYP_VANE		5
#define   STYP_ME		6
#define   STYP_SOLID	7
#define   STYP_FIBRE	8

// Struktur Daten anlegen
typedef struct
{
    float32 fKmotor;
    float32 fCurrRes;
	float32	fEncoderConst;			// Encoder constant
	float32 afC[DEVCONST_TAB_LEN];	// Details for the device, device constants
}t_stcDev;

// Struktur Daten anlegen
typedef struct
{
	float32 afC[SENCONST_TBL_LEN];			// Details for the device, device constants
}t_stcSensor;

void DeviceSensorInit(void);

//float GetDeviceEncoderData(void);

float* PtrDevicetype(void);
float* PtrCal1Motor(void);
float* PtrImResolution(void);
float* PtrCrKP(void);
float* PtrCrD0(void);
float* PtrTorqueMax(void);
float* PtrOmegaMax(void);
float* PtrRawdataFlag(void);
float* PtrInertiaDevice(void);
float* PtrInertiaSensor(void);
float* PtrSensorA(void);
float* PtrSensorM(void);
float* PtrSensorCompliance(void);
float* PtrEncoderConst(void);

float* PtrIoff1Ampl(void);
float* PtrIoff2Ampl(void);
float* PtrIoff3Ampl(void);
float* PtrIcal1Ampl(void);
float* PtrIcal2Ampl(void);
float* PtrIcal3Ampl(void);

float* PtrPolAngle(void);

