/*!
\file	diagnos.h
\brief	Vereinbarungen Diagnose Funktionen

\author	Koester
\date	29.01.2008

*/

/* Include files ************************************************************/
	

/* Macro definitions ********************************************************/

#define	CLEAR		0
#define	SET			1
#define	PROOF		2
#define CLEARALL	11
#define GET			99

#define CPU			0
#define IP			1
#define MOTORCON	2
#define COMM		3
#define PWM			4
#define MEMALLOC    5

// Statusbits fr CPU
#define CPU_NOERROR	0x0000
#define CPU_INIT	0x0001
#define CPU_RUN		0x0002
#define CPU_REFRDY	0x0003
#define CPU_MAGRDY	0x0004
#define CPU_MAGERR	0x0010

// Statusbits fr IP-Test
#define IP_NOERROR	0x0000
#define IP_ERR		0x0001	// Error occured during normal operation, no details
#define IP_RECEVID	0x0002	// wrong ID received
#define IP_EETIME	0x0004	// Timeout EEPROM 
#define IP_EECONF	0x0008	// wrong EEPROM configuration, there is no EEPROM in Hardware
#define IP_CFG1		0x0010	//
#define IP_CFG2		0x0020	//
#define IP_RSVCONF	0x0040	// 
#define IP_REFOK	0x8000	// Reference found

// Statusbits for Motorcontrol
#define MC_NOERROR		0x0000
#define MC_ADC_RECCONF	0x0001
#define MC_ADC_NODATA	0x0002
#define MC_N_MAX		0x0004
#define PWM_OVCUR		0x0008
#define MC_REF_MAGNET	0x0010
#define MC_REF_MAGN_OK	0x1000


// State bits for PWM modul
//#define PWM_NOERROR	0x0000
//#define PWM_OVCUR		0x0001

// Statusbits for Communication
#define SSI_NOERROR	0x0000
#define ERR_SSI_IV	0x0001




typedef struct
{
	// Diagnosis, one each object
	Uint16 ausDs[6];		// 1 Status je Speicherbaustein
}t_stcDiagnoseData;


void InitDiagnosStates(void);
void DiagnosCheckStates(void);

Uint16* PtrDsCpu(void);
Uint16* PtrDsMotorCon(void);
Uint16* PtrDsPwm(void);
Uint16* PtrDsIP(void);
Uint16* PtrDsComm(void);
Uint16* PtrDsMemory(void);

Uint16 ChecksumDataSSI(void *p_pData);
