#ifndef _IP2000_H
#define _IP2000_H

////////////////////////////////////////////////////////////////
//	includes
////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////
//	defines
////////////////////////////////////////////////////////////////

//!< Anzahl, wie viele 16Bit-Werte (1 Spiwort) pro bertragung bertragen werden
#define IP2000_SEND_ANZAHL	3

// Kennung Zhler Kanal0 rcksetzen
#define CLEAR_CNT0			0x0001
// Kennung Referenzsuche Kanal0 starten
#define START_REFSEARCH0	0x0004
// Kennung Referenzsuche Kanal0 starten
#define CLEAR_STAT			0x0010

// Kennung IP Index Status
#define IP_INDEX_FOUND				0x0001
#define IP_INDEX_NOTFOUND			0x0002
#define IP_INDEX_SEARCHACTIV		0x0003
#define IP_INDEX_SEARCHINACTIV		0x0000

// Makros fr den maximalen Zhlerwert des IP2000
#define IP2000_MAX_CNT			5000000

////////////////////////////////////////////////////////////////
//	union + structures
////////////////////////////////////////////////////////////////

//*****************************************************************
/*
 * Makro fr das Setzen des Comperatorwertes fr die genaue Messung
 * zu einem Zeitpunkt
 * Das Signal muss mind. 3/f_OSZ (3/25MHz = 120 ns) Takte anliegen
 */
//*****************************************************************
#define IP2000_SET_TRIGGER(CMPWERT)			EPwm3Regs.CMPB = CMPWERT


//*****************************************************************
/*
 * Array fr den empfangenen umgerechneten Winkel
 * (Wertebereich 0..1)
 */
//*****************************************************************
//#define ANGLE_MEASURE_TIMES_BETWEEN_FOC		FOC_BERECHNUNG_ALLE_X_MAL
#define ANGLE_MEASURE_TIMES_BETWEEN_FOC	1

#ifdef RAUS
struct ANGLE_SEP 
	{
		float measure1;
	};

struct ANGLE_ARRAY
{
	float array[1];
};

typedef union _ANGLE_CONT{
	struct ANGLE_ARRAY				all;
	struct ANGLE_SEP				separate;
} ip2000_angle_cont;
#endif

////////////////////////////////////////////////////////////////
//	external declarations
////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////
//	function declaration
////////////////////////////////////////////////////////////////

volatile int32* PtrIp2000Cnt(void);
Uint16 Ip2000Init(void);
void IP2000GetTrigData(float32* fAngle);
long IP2000GetCntData(void);


////////////////////////////////////////////////////////////////
#endif
