/* ==============================================================================
System Name:  PMSM31

File Name:	PMSM3_1.H

Description:	Primary system header file for the Real Implementation of Sensored  
          		Field Orientation Control for a Three Phase Permanent-Magnet
          		Synchronous Motor (PMSM) using QEP sensor

Originator:		Digital control systems Group - Texas Instruments

Note: In this software, the default inverter is supposed to be DMC1500 board. 
=====================================================================================
 History:
-------------------------------------------------------------------------------------
 04-15-2005	Version 3.20: Support both F280x and F281x targets 
 04-25-2005 Version 3.21: Move EINT and ERTM down to ensure that all initialization
 						  is completed before interrupts are allowed.
=================================================================================  */

#ifndef PMSM3_1_H
#define PMSM3_1_H

//#include "target.h"

/*-------------------------------------------------------------------------------
Next, Include project specific include files.
-------------------------------------------------------------------------------*/


#endif   // end of PMSM3_1.H definition

float* PtrFocSetCurrent(void);
Uint16* PtrFocState(void);
Uint16* PtrFocIntCnt(void);
int32* PtrFocIp2000Cnt(void);
void FocSetToRefMode(void);
void FocSetTestAngleConstant(void);

float* PtrFocTestI1(void);
float* PtrFocTestAngle(void);
float* PtrFocTestI2(void);
float* PtrFocTestI3(void);

//===========================================================================
// No more.
//===========================================================================
