#ifndef _CONTROL_H
#define _CONTROL_H

/***************************************************************************
 *
 * File:         control.h
 * Author(s):    Koester
 * Project:      
 * Description:  
 *                       
 ****************************************************************************/

/* Include files ************************************************************/

/* Macro definitions ********************************************************/

/* Types ********************************************************************/
typedef struct
{	
	float32 fSet;
	float32 fAct;
	float32	fXd;				// Regelabweichung
	float32 fKp;				// P-Verstrkung
	float32	fKi;				// I-Anteil
	float32 fKc;		     	// Integral correction gain
	float32	fYkP;				// P-Anteil Stellgre Proportional output
	float32	fYkI;				// I-Anteil Stellgre Integral output
	float32 fYk;				// complete output
	float32	fOut;				// Stellgroesse PI output
	float32 fSatErr;			// Saturated difference
	float32 fOutMax;		    // Parameter: Maximum output 
	float32 fOutMin;	    	// Parameter: Minimum output
}tStcPiData;


typedef struct
{
	float32 fKPr;			// P-Verstaerkung Rueckfuehrung Drehzahlregelung
	float32 fD0I;			// diskreter Integrationskoeffizient Drehzahlregelung
	float32 fYkPr;			// P-Anteil in Rueckfuehrung Drehzahlregelung
	float32 fYkI;			// I-Anteil Drehzahlregelung
	float32 fYkIold;		// I-Anteil aus voriger Abtastung Drehzahlregelung
	float32 fYk;			// Gesamtstellgroesse (auf Basis Inc) Drehzahlregelung
	float32 fYkMax;			// max. Set value
	float32 fXd;			// Drehzahldifferenz in cts/TA aus aktueller Abtastung
	float32 fXdAlt;			// Drehzahldifferenz in cts/TA aus voriger Abtastung
	float32 fConstNorm;
} t_stcPiRcontrol;

/* Local Prototypes *********************************************************/

/* Global variables *********************************************************/

/* Functions ****************************************************************/

float ControlPi(tStcPiData* p_Data);

void ControlPiRInit(t_stcPiRcontrol *tCrPtr);
float ControlPiR(t_stcPiRcontrol *tCrPtr, float p_fSetValue, float p_fMeasValue);

#endif
