#ifndef _Correction_H
#define _Correction_H

/***************************************************************************
 *
 * File:         Correction.h
 * Author(s):    Koester
 * Project:      
 * Description:  
 *                       
 ****************************************************************************/

/* Include files ************************************************************/

/* Macro definitions ********************************************************/
#define DEVICE	1
#define SENSOR	2
#define DEV_AND_SENS	3

#define MSC_AVG	5

/* Types ********************************************************************/

/* Local Prototypes *********************************************************/

/* Global variables *********************************************************/

/* Functions ****************************************************************/

void CorrLoadConstTable(void);
void CorrLoadModeTable(void);

void SetCondCorrections(void);

void FriStartDatAq(void);
float* PtrFrictionBconst(void);
float32 FrictionCorr (float32 fOmega);

float32 G1Corr (float32 fPhiAmpl);
float32 G2Corr (float32 fPhiAmpl);

float32 ComplianceCorrection(float32 p_fPhi0, float32 p_fM0);
float32 InertiaCorrection (int p_nMode, float32 p_fSlope, float32 p_fOmega);

void CorrResetBuffer(float32 *pafBuf);
void MscTblAddAvgBuffer(void);
void CorrMscClearAvgBuffer(void);
void CorrMscTblAvgCalc(void);

Uint16* PtrMscState(void);
Uint16* PtrMscAvgCnt(void);
Uint16* PtrMscCorrMode(void);
float32* PtrCorrMscTbl(Uint16 pusN);
float32* PtrCorrMscDc(void);

#endif
