#ifndef _Omega_H
#define _Omega_H

/***************************************************************************
 *
 * File:         omega.h
 * Author(s):    Koester
 * Project:      
 * Description:  
 *                       
 ****************************************************************************/

/* Include files ************************************************************/

/* Macro definitions ********************************************************/
//#define PHIMEMORY 250


#define DEEP_250	((Uint16) 250)
#define DEEP_25		((Uint16) 25)
#define DEEP_10		((Uint16) 10)

// for calculating acceleration
#define ACCEL_LENGTH    25  // data buffer for regression
#define ACCEL_TIME      (float)1.0 // 1 second

/* Types ********************************************************************/

// structure data for Accelaration
typedef struct
{
    Uint16	unLen;                      // number of data for Moving Average Filter
    Uint16	unState;                    // state of Filter 0 - in progress, 1 - Ready
    Uint16  unIdx;                      // Index calculated from Phi-absolute
    Uint16  unDecFac;                   // counter for decimation samples
    float32 fSmpTm;                     // sample Time for Regression
    float32 afDatBuf[ACCEL_LENGTH];     // DataBuffer with N elements
    float32 fOut;
    objMavg objSigLinReg;               // object for linear Regression
} t_stcOmgAccel;


/* Struktur fr Omegawerte */


/* Local Prototypes *********************************************************/

/* Global variables *********************************************************/
extern t_FOLPF	sFOLPFOmega;

/* Functions ****************************************************************/

void OmgInitSigAccLinReg(t_stcOmgAccel *p_stcSig);
float32 OmgSigAccLinReg(t_stcOmgAccel *p_stcSig, float32 p_fActSig);

void OmegaSetCondCalc(float32 p_fFreq, float32 p_fSamplT, float32 p_fMeasTime);
void OmegaSetCondAvg(float32 p_fSamplT, float32 p_fMeasTime);
void OmegaInitFilter(float32 p_fValue);
void SetConstOmegaCalc(float p_fTabTast);
void SetCondFolpOmega(float32 fFreq, float32 fTime);
void OmegaCalculation (void);
float* PtrOmegaRaw(void);
float* PtrOmegaFolp(void);
float* PtrOmegaAvg(void);
float* PtrOmegaOld(void);
float* PtrOmegaAccelaration(void);

void StoreOmegaEmavOut(float32 p_dValue);
void StoreOmegaOld(float32 p_dOmega);

void OmegaResetAccelaration(void);
void AngleAccelaration (void);


#endif
