/*
 * Verpflichtendes #include der Header - Datei welche die Makros, 
 * benutzerdefinierten Datentypen, globale und lokale Variablen und die 
 * Prototypen von global sichtbaren Funktionen beinhaltet.
 */
#define MYCONST_C
#include "Project.h"		// all global things as Type definitions, Hardware def., ...
//#include "MyConst.h"


/******************************************************************************
 * An dieser Stelle des Programmes werden die lokalen Funktionsprototypen     *
 * deklariert.                                                                *
 ******************************************************************************/



/******************************************************************************
 * An dieser Stelle des Programmes werden die global sichtbaren Funktionen    *
 * definiert.                                                                 *
 ******************************************************************************/
#ifdef RAUS
/*
 *	Bestimmung der Zahlenbasis.
 */
Uint16 NumberBasis(void)
{
   float64 x, one, b;

   x = one = b = 1.0;
   
   while (((x + one) - x) == one)
   {
      x *= 2.0;
   }

   while ((x + b) == x)
   {
      b *= 2.0;
   }

   return (Uint16) ((x + b) - x);
}

/*
 *	Bestimmung der relativen Zahlengenauigkeit von Gleitpunktpunktzahlen.
 */
float64 RelAccuracy(void)
{
   float64 eps, x;

   eps = 1.0;
   x = 2.0;

   while (1.0 < x)
   {
      eps *= 0.5;
      x = 1.0 + eps;
   }

   return (eps * 2.0);
}

/*
 *	Bestimmung des maximal zulaessigen Wertebereiches einer Wortvariablen.
 */
Uint16 MaxWord(void)
{
   float64     summe, z, b;
   Uint16   i, exp;

   summe = 0.0;
   z = 1.0;
   b = 2.0;
   exp = sizeof(Uint32)*8 - 1;

   for (i = 0; i < exp; i++)
   {
      z *= b;
      summe += z;
   }

   return (Uint16) (summe + 1.0);
}

/*
 *	Bestimmung des maximal zulaessigen Wertebereiches einer Bytevariablen.
 */
Uint8 MaxByte(void)
{
   float64  summe, z, b;
   Uint8 i, exp;

   summe = 0.0;
   z = 1.0;
   b = 2.0;
   exp = sizeof(Uint8)*8 - 1;


   for (i = 0; i < exp; i++)
   {
      z *= b;
      summe += z;
   }
   
   return (Uint8) (summe + 1.0);
}
#endif

/******************************************************************************
 * An dieser Stelle des Programmes werden die lokalen Funktionen definiert.   *
 * Die Beschreibung (Bedeutung der Parameter, Rueckgabewerte und Rand-        *
 * bedingungen) der internen Funktionen erfolgt an dieser Stelle.             *
 ******************************************************************************/
